package consommation;

import java.io.IOException;

import com.fasterxml.jackson.core.JsonParseException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonMappingException;

public class TestConsommation {
    
    
    /**
     * @param args
     * @throws IOException 
     * @throws JsonProcessingException 
     * @throws JsonMappingException 
     * @throws JsonParseException 
     */
    
    //@todo  : A gerer sous forme de tests unitaires!!
    public static void main(String[] args) throws JsonParseException, JsonMappingException, JsonProcessingException, IOException {

    
     //    quelle est la consommation moyenne du modle Clio sur Route (rep. 6,3)? urbaine(rep. 8,1)?
    Consommation clioMoyenneRoute = new Consommation(6.3, Unite.LITRES_PAR_100KM);
    Consommation clioMoyenneUrbaine = new Consommation(8.1, Unite.LITRES_PAR_100KM); 
    ConsommationMoyenne cmClio = new ConsommationMoyenne(clioMoyenneRoute,clioMoyenneUrbaine);
    ModeleDeVoiture mv = new ModeleDeVoiture("Clio",cmClio);
    System.out.println("Consommation de clio, 6.3 : " + mv.consommation(TypeRoute.route));
    System.out.println("Consommation de clio, 8.1 : " + mv.consommation(TypeRoute.urbain));
   //quelle est la consommation moyenne d'une Clio  150km/h? (mettons que le coefficient est de 3,85*10^-4 et donc une rponse de quasi 10,  ce qui n'est pas du tout la ralit!!! ).
    long nombre = 10; 
    long exposant = -4; 
    double coeff = 3.85* Math.pow( nombre,exposant); 
    System.out.println("Coeff : " + coeff);
    ConsommationFonctionVitesseAvecCoefficient cv = new ConsommationFonctionVitesseAvecCoefficient(coeff);
    Vitesse v = new Vitesse(150);
    System.out.println("Consommation moyenne d'une Clio  150km/h ~10: " + cv.consommationSiVitesse(v));
    mv.setConsommationFonctionVitesse(cv);
    System.out.println("Consommation moyenne d'une Clio  150km/h ~10: " + mv.consommationSiVitesse(v));
    
   // On vient d'tablir une formule 2) qui, pour certains modles de voitures,  partir des donnes connues en circulation urbaine ou sur route permet de dterminer le coefficient K, selon la formule suivante : Au dessus de 100 km/h on prend en compte la consommation sur route que l'on multiplie par 10^-4, entre 100 et 50, la consommation mixte et en dessous urbaine. Quelle modlisation proposez-vous ? Quel est le couplage entre vos classes? Avez-vous bien support l'extension? Il existe plusieurs solutions possibles, c'est  vous de dcider!
    
    
    //F FERRARI F430    Essence 357 26.90   13.30   18.30
    Consommation ferrariUrbain = new Consommation(26.90,Unite.LITRES_PAR_100KM);
    Consommation ferrariRoute = new Consommation(13.30,Unite.LITRES_PAR_100KM);
    Consommation ferrariMixte = new Consommation(18.30,Unite.LITRES_PAR_100KM);
    ConsommationMoyenne cmFerrari = new ConsommationMoyenne(ferrariRoute,ferrariUrbain,ferrariMixte);
    ModeleDeVoiture ferrariF430= new ModeleDeVoiture("ferrariF430",cmFerrari);
    ConsommationFonctionVitesseInterface cfvFerrari = new ConsommationFonctionVitesseFonctionMoyennes(ferrariRoute, ferrariUrbain, ferrariMixte);
    ferrariF430.setConsommationFonctionVitesse(cfvFerrari);
    System.out.println(ferrariF430);
    v.setValeur(150);
    System.out.println("A 150km/h"+ ferrariF430.consommationSiVitesse(v));
    v.setValeur(90);
    System.out.println("A 90/h"+ ferrariF430.consommationSiVitesse(v));
    v.setValeur(30);
    System.out.println("A 30km/h"+ ferrariF430.consommationSiVitesse(v));
    
    
    
    ServiceExterne se = new ServiceExterne();
    ferrariF430.setConsommation(new ConsommationMoyenneExterne(se,"ferrariF430"));
    System.out.println("Tests Consommations externes : " + se.consommationJSON("ferrariF430") );
    
    System.out.println("Ferrari sur Route : " + ferrariF430.consommation(TypeRoute.route) );
    System.out.println("Ferrari Urbaine : " + ferrariF430.consommation(TypeRoute.urbain) );
    
    
    Calculateur c = new Calculateur();
    double distance = 100;
    double vitesse = 130;
    System.out.println("Ferrari conso sur 100km fonction vitesse " + c.calculerConsommationFonctionVistesse(ferrariF430,distance,vitesse) + "litres");
    System.out.println("Ferrari conso sur 100km fonction typeRoute : route " + c.calculerConsommation(ferrariF430,distance,TypeRoute.route));
    System.out.println("Ferrari conso sur 100km fonction typeRoute : urbain " + c.calculerConsommation(ferrariF430,distance,TypeRoute.urbain));
    

    System.out.println("conso fonction vitesse " + c.calculerConsommationFonctionVistesse(mv,distance,vitesse));
    System.out.println("conso fonction typeRoute : route" + c.calculerConsommation(mv,distance,TypeRoute.route));
    System.out.println("conso fonction typeRoute : urbain" + c.calculerConsommation(mv,distance,TypeRoute.urbain));
  

    
    }        
}
