package consommation;

import com.fasterxml.jackson.annotation.JsonTypeInfo;


@JsonTypeInfo(use=JsonTypeInfo.Id.CLASS, include=JsonTypeInfo.As.PROPERTY, property="@class")
public abstract class Unite{

    String ident;
    
    public String getIdent() {
        return ident;
    }
 
    public void setIdent(String ident) {
        this.ident = ident;
    }

    public String toString() {
        return "" + ident + "";
    }
    
    public Unite(String ident) {
        this.ident = ident;
    }

    //Pas sure de cette gestion des Units par des constantes dans cette classe
    public static final UniteSimple METRE = new UniteSimple("metre");
    public static final UniteSimple KM = new UniteSimple("KM");
    public static final UniteSimple HEURE = new UniteSimple("Heure");
    public static final UniteSimple CENT_KM = new UniteSimple("CENT_KM");
    public static final UniteSimple LITRE = new UniteSimple("litre");
    public static final UniteComposite LITRES_PAR_100KM = new UniteComposite(LITRE,CENT_KM);    
    public static final UniteComposite KM_PAR_HEURE = new UniteComposite(KM,HEURE);
    
    
    
	
	public double convert(double aValeur, Unite aUCible) {
		throw new UnsupportedOperationException();
	}


/* Exercice prvu mais retir du sujet : 
 * public ArrayList<ConvertisseurUnitaire> _unnamed_ConvertisseurUnitaire_ = new ArrayList<ConvertisseurUnitaire>();
 * public ConvertisseurUnitaire getConvertisseur(Unite aUCible) throws NoConvertisseur {
		throw new UnsupportedOperationException();
	}
*/
}