package consommation;

public class ModeleDeVoiture {
	private String nom;
	//public ConsommationMoyenneInterface consommationsMoyennes;

	public DonneesDeConsommationInterface donneesDeConsommation;


   public ModeleDeVoiture(String modele) {
       nom = modele;
       donneesDeConsommation = new DonneesDeConsommation();
    }
 
   //Je choisis la cascade dans ce sens parce que je ne tiens pas  initialiser les variables par dfaut
   public ModeleDeVoiture(String modele, ConsommationMoyenneInterface conso) {
        this(modele);
        donneesDeConsommation.setConsommationMoyenne(conso);
    }
  
    public Consommation consommation(TypeRoute aSorte) {
		return donneesDeConsommation.consommation(aSorte);
	}

	public Consommation consommationSiVitesse(Vitesse aV) {
		return donneesDeConsommation.consommationSiVitesse(aV);
	}

    @Override
    public String toString() {
        return "ModeleDeVoiture [nom=" + nom + ", consommationsMoyennes="
                + donneesDeConsommation + "]";
    }

    public void setConsommationFonctionVitesse(
            ConsommationFonctionVitesseInterface cv) {
        donneesDeConsommation.setConsommationFonctionVitesse(cv);
                
    }

    public void setConsommation(
            ConsommationMoyenneInterface consommationMoyenne) {
            donneesDeConsommation.setConsommationMoyenne(consommationMoyenne);
        
    }
	
	
}